#ifndef __AMSCPPPERM1_HPP__
#define __AMSCPPPERM1_HPP__

#include <stdio.h>
#include <stdlib.h>
#include <math.h>


namespace ams
{
namespace perm
{

//Basic operations on preallocated buffers
//for later C library export

int factorial(int n);

int index_to_mindex(int index, int *mindex, int ndim);

int mindex_to_index(int *mindex, int ndim);
void mindex_to_perm(int *mindex, int *perm, int ndim);
void perm_to_mindex(int *perm, int *mindex, int ndim);

bool perm_valid(int *perm, int ndim);

bool mindex_valid(int *mindex, int ndim);

void index_to_perm(int index, int *perm, int ndim);
int perm_to_index(int *perm, int ndim);




//Permutation class
class permutation
{
public:
    int dim;
    int *data;

    permutation();
    permutation(int _dim);
    ~permutation();
};

}; //end namespace perm
}; //end namespace ams

#endif